#ifndef DUP_H
#define DUP_H

///////////////////////////////////////////////////////////////
//                                                           //
// dup.h - traverse subtree below specified Directory,       //
//         record duplicated file names and display them.    //
//                                                           //
//                                                           //
// Developed By Qiang Zheng From Dr. Fawcett's example.		 //
// Apr. 08 1999												 //
//															 //
///////////////////////////////////////////////////////////////

// disable truncation warnings
#pragma warning( disable : 4786 ) 

#include <iostream>
#include <iomanip>
#include <cstring> 
#include <windows.h>
#include <string>
#include <set>
#include <string>
#include <map>
#include <list>
#include "dirNav.h"

using namespace std;

// This virtual class is the base class of required "CLEAN" and "DUPS"
// class, i.e. it is a public interface	
class dup : public dirNav {
	set< string > fileNameSet;
	map< string , list< string > > fileNpath;
public:
	dup() {}
	~dup() {}

	void printResult();
	// Implement the virtual functions in dirNav class

	// Do nothing when navigator enters a directory
	/* virtual */ inline void preProcessDir( const char * dirName ) { }

	// Pop user's instruction off the userReplayStack when leaving a directory
	/* virtual */ inline void postProcessDir( const char * dirName ) { }

	// Special actions to be performed when files are encountered
	/* virtual */ void processFile(const char * dirName, const char * fName);

	// void performF( const char * fName, const char userAnswer );
};

#endif